<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration,
    Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your need!
 */
class Version20131216214117 extends AbstractMigration
{
    public function up(Schema $schema)
    {
        // this up() migration is autogenerated, please modify it to your needs
        if (!$this->isTableExist('money_card')) {
        	$this->addSql("
				CREATE TABLE `money_card` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `cardId` varchar(32) NOT NULL,
				  `password` varchar(32) NOT NULL,
				  `deadline` varchar(19) NOT NULL COMMENT '有效时间',
				  `rechargeTime` int(10) NOT NULL COMMENT '充值时间，0为未充值',
				  `cardStatus` enum('normal','invalid','recharged') NOT NULL,
				  `rechargeUserId` int(11) NOT NULL,
				  `batchId` int(11) NOT NULL,
				  PRIMARY KEY (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        	");
        }

        if (!$this->isTableExist('money_card_batch')) {
        	$this->addSql("
				CREATE TABLE `money_card_batch` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `cardPrefix` varchar(32) NOT NULL,
				  `cardLength` int(8) NOT NULL,
				  `number` int(11) NOT NULL,
				  `rechargedNumber` int(11) NOT NULL,
				  `deadline` varchar(19) NOT NULL,
				  `money` int(8) NOT NULL,
				  `userId` int(11) NOT NULL,
				  `createdTime` int(11) NOT NULL,
				  `note` varchar(128) NOT NULL,
				  PRIMARY KEY (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        	");
        }

        if (!$this->isTableExist('user_level')) {
        	$this->addSql("
				CREATE TABLE `user_level` (
				  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
				  `seq` int(11) NOT NULL,
				  `Name` varchar(64) NOT NULL COMMENT '名称',
				  `icon` varchar(255) NOT NULL COMMENT '图标',
				  `enabled` int(1) NOT NULL COMMENT '状态',
				  `createdTime` int(11) NOT NULL COMMENT '创建时间',
				  PRIMARY KEY (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8;
        	");
        }
    }

    public function down(Schema $schema)
    {
        // this down() migration is autogenerated, please modify it to your needs

    }

    protected function isTableExist($table)
    {
        $sql    = "SHOW TABLES LIKE '{$table}'";
        $result = $this->connection->fetchAssoc($sql);
        return empty($result) ? false : true;
    }
}
